/*
 * compile:			

gcc -nostdlib -fno-zero-initialized-in-bss -fno-function-cse -fno-jump-tables -Wl,-N -fPIE echo.c

 * disassemble:			objdump -d a.out
 * confirm no relocation:	readelf -r a.out
 * generate executable:		objcopy -O binary a.out b.out
 *
 * and then the resultant b.out will be grub4dos executable.
 */

/*
 * This is a simple ECHO command, running under grub4dos.
 */
#include "grub4dos.h"
int i = 0x66666666;	/* this is needed, see the following comment. */

/* gcc treat the following as data only if a global initialization like the
 * above line occurs.
 */

/* a valid executable file for grub4dos must end with these 8 bytes */
asm(".long 0x03051805");
asm(".long 0xBCBAA7BA");
/* thank goodness gcc will place the above 8 bytes at the end of the b.out
 * file. Do not insert any other asm lines here.
 */

int
main()
{
      void *p = &main;
      /* the following line includes arguments passed to grub_sprintf. */
   char *arg=p - (*(int *)(p - 8));
   return printf("%s",arg);

	/* the following line is calling the grub_sprintf function. */
/*	((int (*)(char *, const char *, ...))((*(int **)0x8300)[0])) */
	/* the following line includes arguments passed to grub_sprintf. */
/*		(0, p - (*(int *)(p - 8)));*/
}
